/*  DO NOT EDIT THIS FILE.

    It has been auto-edited by fixincludes from:

	"/usr/include/sys/user.h"

    This had to be done to correct non-standard usages in the
    original, manufacturer supplied header file.  */

/**************************************************************************
 *									  *
 * 		 Copyright (C) 1989-1992, Silicon Graphics, Inc.	  *
 *									  *
 *  These coded instructions, statements, and computer programs  contain  *
 *  unpublished  proprietary  information of Silicon Graphics, Inc., and  *
 *  are protected by Federal copyright law.  They  may  not be disclosed  *
 *  to  third  parties  or copied or duplicated in any form, in whole or  *
 *  in part, without the prior written consent of Silicon Graphics, Inc.  *
 *									  *
 **************************************************************************/
/*	Copyright (c) 1984 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

#ifndef __SYS_USER_H__
#define __SYS_USER_H__
#ident	"$Revision: 3.95 $"

#if defined(_KERNEL) || defined(_KMEMUSER)
#include <sys/types.h>
#include <sys/immu.h>		/* UADDR, MAXPSEGS */
#include <sys/pcb.h>		/* pcb_t */
#include <sys/reg.h>		/* EF_ELEM */
#include <sys/resource.h>	/* RLIM_NLIMITS */
#include <sys/profil.h>		/* struct prof */
#include <sys/sbd.h>		/* NWIREDENTRIES etc. */
#include <sys/signal.h>
#include <sys/time.h>		/* struct itimerval */
#include <sys/syscall.h>	/* sysset_t */
#include <sys/fault.h>		/* fltset_t */
#include <sys/vnode.h>		/* struct vattr */
#include <sys/uio.h>		/* struct uio */
#include <sys/ufchunk.h>	/* struct ufchunk */

struct polldat;
struct soacl;

/*
 * The user structure.
 * One allocated per process.
 * Contains all per process data that doesn't need to be referenced
 * while the process is swapped.
 * The user block is USIZE*click bytes long;
 * resides at virtual kernel UADDR (defined in sbd.h);
 * is cross referenced with the proc structure for the same process.
 */

#define	UF_CLOSEXEC	0x1	/* close file descriptor on exec */
#define UF_FDLOCK	0x2	/* file descriptor locked (SysV-style) */
#define	UF_NODUPFORK	0x4	/* don't dup fd on fork */

#define	PSARGSZ		80	/* Space in u-block for exec arguments.	*/
				/* Used by ps command.			*/

#define	PSCOMSIZ	32	/* Space in u-block for program being execed */

typedef	struct	user
{
	union {
		pcb_t		__u_pcb;		/* MUST be first */
		ex_pcb_t	__u_ex_pcb;
	} u_pcb_un;
#define	u_pcb	u_pcb_un.__u_pcb

	union {
		eframe_t	__u_eframe;	/* saved exception state */
		ex_eframe_t	__u_ex_eframe;
	} u_eframe_un;
#define u_eframe	u_eframe_un.__u_eframe

	union {
		label_t	__u_qsav;		/* label variable for quits */
						/* and interrupts */
		exlabel_t	__u_ex_qsav;
	} u_qsav_un;
#define u_qsav	u_qsav_un.__u_qsav

	union {
		k_machreg_t	__u_flt_cause;	/* cause of ext. memory fault */
		__uint64_t	__u_ex_flt_cause;
	} u_flt_cause_un;
#define u_flt_cause	u_flt_cause_un.__u_flt_cause

	union {
		k_machreg_t	__u_flt_badvaddr; /* vaddr of ext. mem. fault */
		__uint64_t	__u_ex_flt_badvaddr;
	} u_flt_badvaddr_un;
#define u_flt_badvaddr	u_flt_badvaddr_un.__u_flt_badvaddr

	caddr_t		u_depth;	/* allow nesting */

	int 		(*u_sigtramp)();/* address of user's signal return */
					/* handler: _sigtramp in libc	*/

	caddr_t		u_siglb;	/* lower bound of sigstack */
	stack_t		u_sigstack;	/* sp & on stack state variable */
#define	u_ssflags	u_sigstack.ss_flags
#define	u_sigsp		u_sigstack.ss_sp
#define	u_spsize	u_sigstack.ss_size
	int		u_restoremask;	/* does u_suspmask need replacing? */

	int		u_segflg;	/* see <sys/uio.h> enum uio_seg */
	int		u_error;	/* return error code */

	void		*u_oldcontext;	/* previous user context */
	k_sigset_t	u_signodefer;	/* signals defered when caught */
	k_sigset_t	u_sigrestart;	/* signals that restat system calls */
	k_sigset_t	u_sigresethand;	/* signals reset when caught */
        k_sigset_t      u_sigonstack;   /* use sigstack for signals */
	k_sigset_t	u_suspmask;	/* real mask, swapped in sigsuspend */

	struct proc	*u_procp;	/* pointer to proc structure */

	sysarg_t	*u_ap;		/* pointer to arglist */
	union user_u_r {		/* syscall return values */
		struct	{		/* MUST MATCH systm.h's rval_t */
			long	r_v1;
			long	r_v2;
		} r_reg;
		scoff_t	r_off;
		time_t	r_time;
	} u_r;

	caddr_t		u_base;		/* base address for IO */
	u_int		u_count;	/* bytes remaining for IO */
	off_t		u_offset;	/* offset in file for IO */
	short		u_errcnt;	/* syscall error count */

	struct vnode	*u_cdir;	/* current directory */
	struct vnode	*u_rdir;	/* root directory */

	off_t		u_scanpos;	/* offset into last scanned dir */
	ino_t		u_scaninum;	/* inum and dev of last scanned dir */
	dev_t		u_scandev;
	sysarg_t	u_arg[8];	/* arguments to current system call */

	u_int		u_orgtsize;	/* original text size (bytes) */
	u_int		u_orgdsize;	/* original data size (bytes) */
	u_int		u_orgbsize;	/* original bss size (bytes) */

	eframe_t	*u_ar0;		/* address of users saved R0 */

	struct prof	*u_profp;	/* pointer to list of prof structures */
	short		u_profn;	/* number of prof structures in list */

	long		u_execsz;

	char		u_comm[PSCOMSIZ];
	char		u_psargs[PSARGSZ]; /* arguments from exec system call */

	char		*u_tracepc;	/* Return PC if tracing enabled */
	int		u_sysabort;	/* Debugging: if set, abort syscall */
	int		u_systrap;	/* Are any syscall mask bits set? */
	sysset_t	u_entrymask;	/* syscall stop-on-entry mask */
	sysset_t	u_exitmask;	/* syscall stop-on-exit mask */
	fltset_t	u_fltmask;	/* fault tracing mask for /proc */
	u_int		u_dbgflags;	/* flags for low-freq /proc events */
	u_int		u_cursig;	/* current signal */

	time_t		u_start;
	time_t		u_ticks;
	u_long		u_mem;
	u_long		u_iosw;
	u_long		u_ioch;
	char		u_acflag;

	char		u_lock;		/* process/text locking flags */
	char		u_dorlimit;	/* give Berkeley SIGXFSZ, when set */
	char		u_pnbuffree;	/* whether u_pnbuf is free */
	char		*u_pnbuf;	/* pathname buffer for pn_alloc */

	short		u_cmask;	/* mask for file creation */

	struct itimerval u_timer[3];	/* interval timers */

	int		u_caddrflt;	/* index into table of functions to */
					/* handle user space external memory */
					/* faults encountered in kernel */
	unsigned int	u_tlbcnt;	/* count of random TLB dropins	*/
					/* of second-level misses	*/

	caddr_t		u_eaaddr;	/* emulate area address */
	pid_t		u_unblkonexecpid; /* pid to unblock on exec */
	short		u_exitsig;	/* signal to send on exit of shgrp */
	int		u_code;		/* trap error code */
	struct monitor	*u_monitor;	/* pointer to current monitor */

	/* The following 3 fields only referenced if !NO_WIRED_SEGMENTS:
	 *	u_pde, u_tlbhi_tbl, u_nexttlb
	 * NOTE: We define the following fields if NWIREDENTRIES is defined
	 * rather than testing for !NO_WIRED_SEGMENTS.  This is so we can
	 * define these fields as placeholders in the uarea even if we are
	 * executing without wired segments.
	 */
#if NWIREDENTRIES
	union {
		pde_t	u_pde_ubptbl[NWIREDENTRIES-TLBWIREDBASE];
					/* page table entries for the	*/
					/* page tables, et al,	*/
					/* to avoid double misses */
		tlbpde_t u_tlbpde_ubptbl[NWIREDENTRIES-TLBWIREDBASE];
	} u_pde;
	caddr_t		u_tlbhi_tbl[NWIREDENTRIES-TLBWIREDBASE];
					/* virtual addresses to go with */
					/* above page table		*/
	u_char		u_nexttlb;	/* index for next available	*/
					/* entry in above tables	*/
#endif	/* NWIREDENTRIES */

	u_long		u_tfaults;		/* # of 2nd level tfaults */
	u_long		u_vfaults;		/* # of vfaults */
	u_long		u_ufaults;		/* # of utlb misses */
	u_int		u_triggersave;		/* state of 3-way trigger h/w */
	struct rlimit	u_rlimit[RLIM_NLIMITS];	/* 4.3BSD resource limits */

	/*
	 * Compatibility macros that access fields in the rusage structs.
	 * Also declerations for PIOCUSAGE (/proc).
	 * Note that u_utime, u_stime, u_cutime and u_cstime reflect time in
	 * clock ticks (HZ), not seconds.
	 */
#if !STAT_TIME
#define u_cutime	u_cru.ru_utime
#define u_cstime	u_cru.ru_stime
#define u_utime		u_ru.ru_utime
#define u_stime		u_ru.ru_stime
#else
#define u_cutime	u_cru.ru_utime.tv_sec
#define u_cstime	u_cru.ru_stime.tv_sec
#define u_utime		u_ru.ru_utime.tv_sec
#define u_stime		u_ru.ru_stime.tv_sec
#endif /* !STAT_TIME */
#define u_ior		u_ru.ru_inblock
#define	u_iow		u_ru.ru_oublock
	struct rusage	u_ru;		/* stats for this proc */
	struct rusage	u_cru;		/* sum of stats for reaped children */
	u_long		u_gbread;	/* # of of gigabytes of input */
	u_long		u_bread;	/* # of bytes of input */
	u_long		u_gbwrit;	/* # of of gigabytes of output */
	u_long		u_bwrit;	/* # of bytes of output */
	u_long		u_sysc;		/* # of syscalls */
	u_long		u_syscr;	/* # of read system calls */
	u_long		u_syscw;	/* # of write system calls */
	u_long		u_syscps;	/* # of poll/select system calls */
	u_long		u_sysci;	/* # of ioctl system calls */
	u_long		u_graphfifo;	/* # of graphics pipeline stalls */
	u_long		u_syscall;	/* current system call number */
#ifndef _IRIX_LATER
        dev_t		u_ttyd;		/* NOTE:used by SGI_RDUBLK only */
#endif /* !_IRIX_LATER */
	void		(*u_signal[NUMSIGS])();	/* disposition of signals */
        k_sigset_t	u_sigmasks[NUMSIGS];	/* block-masks during handlers */
                                        	/* (for POSIX and BSD signals) */
	u_short		u_satsubsysnum;	/* "sub" system call number (for */
					/* syssgi, etc.) */
	u_short		u_satflag;	/* superuser checks, etc. */
	uid_t		u_satid;	/* SAT user-id (only set by login) */
	struct mbuf	*u_satrec;	/* current SAT record (namei) */
	struct sat_wd	*u_satwd;	/* current wd/root (text form) */
	struct polldat  *u_polldat;	/* polldat for system call select */
	struct soacl 	*u_soacl;	/* soacl for socket creation */
	struct vnode	*u_script;	/* script executed by #!/path/intp */
	caddr_t		u_nofpefrom;	/* disabled fp exception range */
	caddr_t		u_nofpeto;	/* disabled fp exception range */
	caddr_t		u_nofpe;	/* flag of no fpe */
	/* support for shared file descriptors */
	int		u_nofiles;	/* number of open file slots */
	struct ufchunk	*u_flist;	/* open file list */
	cnt_t		*u_fdinuse;	/* current fd in use if any */
	cnt_t		**u_fdmany;	/* if more than one */
	cnt_t		u_fdmanysz;	/* number on fdmany */
	cnt_t		u_fdmanymax;	/* length (in cnt_t*) of fdmany */
	struct file	*u_openfp;	/* hack for usema */
	/*
	 * NOTE: The following union *must* be the last element declared
	 * in the uarea -- the last sizeof(u.u_vfault_un) bytes of
	 * the parent's uarea are not copied during a fork system call.
	 */
	union {
		struct vattr	__u_vattr;
		struct uio	__u_uio;
	} u_vfault_un;
} user_t;

#define u_vattr u_vfault_un.__u_vattr
#define u_uio u_vfault_un.__u_uio

#define u_exuid u_exfile.ux_uid
#define u_exgid u_exfile.ux_gid
#define u_exmode u_exfile.ux_mode

#define	u_rval1	u_r.r_reg.r_v1
#define	u_rval2	u_r.r_reg.r_v2
#define	u_roff	u_r.r_off
#define	u_rtime	u_r.r_time

#endif /* _KERNEL || _KMEMUSER */

#ifdef _KERNEL
/*
 * This "declaration" tells front end it can use r0 relative addressing.
 */
#define	u	(*(struct user *)UADDR)

/*
 * These macros ease the transition to cred's.  They spare us from
 * having to rewrite all the existing code that wants to check uid's.
 * Their values can be read at any time, but stores to them must be
 * done with care since cred structs are shared among processes.
 */
#define	u_cred	u_procp->p_cred
#define u_uid	u_cred->cr_uid
#define u_gid	u_cred->cr_gid
#define u_ruid	u_cred->cr_ruid
#define u_rgid	u_cred->cr_rgid
#define u_mac	u_cred->cr_mac
#define u_inf	u_cred->cr_inf
#define u_cap	u_cred->cr_cap

#define MAX_IOCH	((u_long) (((u_long) (1 << (sizeof(u_long)*NBBY - 1))) - 1))
#define UPDATE_IOCH(uap,incr) \
	((uap)->u_ioch += ((((uap)->u_ioch + (incr)) > MAX_IOCH) ? 0 : (incr)))

#if R4000
#define	u_ubptbl	u_pde.u_tlbpde_ubptbl	/* A pair of pde_t entries */
#endif
#if R3000 || TFP
#define	u_ubptbl	u_pde.u_pde_ubptbl
#endif

/* ioflag values: Read/Write, User/Kernel, Ins/Data */

#define	U_WUD	0
#define	U_RUD	1
#define	U_WKD	2
#define	U_RKD	3
#define	U_WUI	4
#define	U_RUI	5

/* satflag values */
/* Use these as set-only so we don't need to lock */

#define U_SUSERCHK	0x1	/* auditing: superuser was checked */
#define U_SUSERPOSS	0x2	/* auditing: uid == 0 when checked */

#ifndef _IRIX_LATER
#define	EXCLOSE	01
#endif /* !_IRIX_LATER */

#ifdef MIPSEL
#define OBJMAGIC 0x0162
#endif
#ifdef __MIPSEB__
#define OBJMAGIC 0x0160
#endif
#endif /* _KERNEL */

#endif /* __SYS_USER_H__ */
