/*	Copyright (c) 1990, 1991 UNIX System Laboratories, Inc.	*/
/*	Copyright (c) 1984, 1986, 1987, 1988, 1989, 1990 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF     	*/
/*	UNIX System Laboratories, Inc.                     	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

#ifndef _SYS_UTSNAME_H	/* wrapper symbol for kernel use */
#ifndef _PARAMS
#if defined(__STDC__) || defined(__cplusplus)
#define _PARAMS(ARGS) ARGS
#else
#define _PARAMS(ARGS) ()
#endif
#endif /* _PARAMS */
#define _SYS_UTSNAME_H	/* subject to change without notice */

#ifdef __cplusplus
extern "C" {
#endif

#ident	"$Revision: 3.27 $"

/*
 * If you are compiling the kernel, the value used in initializing
 * the utsname structure in kernel.cf must be the same as SYS_NMLN.
 */

#define _SYS_NMLN	257	/* 4.0 size of utsname elements.*/
				/* Must be at least 257 to 	*/
				/* support Internet hostnames.  */


struct utsname {
	char	sysname[_SYS_NMLN];
	char	nodename[_SYS_NMLN];
	char	release[_SYS_NMLN];
	char	version[_SYS_NMLN];
	char	machine[_SYS_NMLN];
	char	m_type[_SYS_NMLN];
	char	base_rel[_SYS_NMLN];
	char	reserve5[_SYS_NMLN];		/* reserved for future use */
	char	reserve4[_SYS_NMLN];		/* reserved for future use */
	char	reserve3[_SYS_NMLN];		/* reserved for future use */
	char	reserve2[_SYS_NMLN];		/* reserved for future use */
	char	reserve1[_SYS_NMLN];		/* reserved for future use */
	char	reserve0[_SYS_NMLN];		/* reserved for future use */
};


#if !defined(_POSIX_SOURCE) && !defined(SYS_NMLN)
#define	SYS_NMLN	_SYS_NMLN
extern struct utsname utsname;
#endif /* !defined(_POSIX_SOURCE) && !defined(SYS_NMLN) */

#ifdef _KERNEL

extern struct utsname	utsname;
extern char		hostname[];
extern short		hostnamelen;
extern char		domainname[];
extern short		domainnamelen;
extern char		uname_release[];
extern char		uname_version[];

#else /* !_KERNEL */

#ifdef _MODERN_C
int nuname(struct utsname *);
#else /* _MODERN_C */
int nuname _PARAMS((struct utsname *));
#endif	/* _MODERN_C */

#ifdef _ABI_SOURCE
static int
#ifdef _MODERN_C
uname(struct utsname *_buf)
#else /* _MODERN_C */
uname(_buf)
	struct utsname *_buf;
#endif /* _MODERN_C */
{
	int ret;
	
	ret = nuname(_buf);
	return ret;
}
#else /* _ABI_SOURCE */
#ifdef _MODERN_C
int uname(struct utsname *);
#else /* _MODERN_C */
int uname _PARAMS((struct utsname *));
#endif	/* _MODERN_C */
#endif /* _ABI_SOURCE */

#endif	/* KERNEL */


#ifdef __cplusplus
}
#endif  /* __cplusplus */
#endif	/* _SYS_UTSNAME_H */
